Attribute VB_Name = "mdlAPI_Variablen"
Option Explicit

'------------------------------------------------------------------------------
Public Declare Function GetVersionEx Lib "kernel32" Alias "GetVersionExA" _
(lpVersionInformation As OSVERSIONINFO) As Long

Public Declare Function GetLogicalDriveStrings Lib "kernel32" Alias "GetLogicalDriveStringsA" _
(ByVal nBufferLength As Long, ByVal lpBuffer As String) As Long

Public Type OSVERSIONINFO
        dwOSVersionInfoSize As Long
        dwMajorVersion As Long
        dwMinorVersion As Long
        dwBuildNumber As Long
        dwPlatformId As Long
        szCSDVersion As String * 128      '  Maintenance string for PSS usage
End Type

Public Const VER_PLATFORM_WIN32s = 0           'Win 3.1 mit 32 bit Erweiterung

Public Const VER_PLATFORM_WIN32_WINDOWS = 1    'Win 9x

Public Const VER_PLATFORM_WIN32_NT = 2         'Win NT/2000/XP

Public Declare Function GetWindowsDirectory Lib "kernel32" _
Alias "GetWindowsDirectoryA" (ByVal lpBuffer As String, ByVal nSize As Long) As Long

Public Retval As Long
Public OS As OSVERSIONINFO
Public InputRet As String
'public Buffer As String
Public WinDir As String
Public WinVal As Long

Public WinPlatformId As Long
Public WinMajorVersion As Long
Public WinMinorVersion As Long
Public WinBuildNumber As Long
Public WinOSVersionInfoSize As Long
Public WinCSDVersion As String
'------------------------------------------------------------------------------

Public Enum NotifyEffects
    NoEffect
    FadeInOut
    ScrollUpDown
End Enum

Public DialogBottom As Long
Public InstanceCount As Long
    
Public ND As NotifyDialog

'API-Funktion um die CommonDialog Controls in XP-Format anzuzeigen
'mit einer Manifest- oder Resourcendatei
Public Declare Function InitCommonControls Lib "comctl32.dll" () As Long 'API Deklaration um initialisation von'CommonDialog zu ermglichen

'**********************************************************
' FARBVERLAUF IN FENSTERN UND OBJEKTEN
' zunchst die bentigten API-Funktionen
Public Declare Function DeleteObject Lib "gdi32" _
  (ByVal hObject As Long) As Long
Public Declare Function CreateSolidBrush Lib "gdi32" _
  (ByVal crColor As Long) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" _
  (ByVal hDC As Long, ByVal nIndex As Long) As Long
Public Declare Function FillRect Lib "user32" _
  (ByVal hDC As Long, lpRect As RECT, _
  ByVal hBrush As Long) As Long

Public Const PLANES = 14
Public Const BITSPIXEL = 12

Public Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type
'**********************************************************

Public Declare Function LockWindowUpdate Lib "user32" _
        (ByVal hwndLock As Long) As Long
        
Public Declare Function GetDesktopWindow Lib "user32" _
        () As Long

Public Declare Function GetSysColor Lib "user32" (ByVal nIndex As Long) As Long
'----------------------------------------------------------------------------------------
'Fenster im Vordergrund halten
'API-Funktion mit Konstanten
Public Declare Function SetWindowPos Lib "user32.dll" _
(ByVal hWnd As Long, ByVal hwndInsertAfter As Long, _
ByVal X As Long, ByVal Y As Long, ByVal cx As Long, _
ByVal cy As Long, ByVal wFlags As Long) As Long
Public Const SWP_SHOWWINDOW = &H2
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2   'Fenster wieder normal


Public Laufwerk As String
Public Eingabe As Long
Public Const Obergrenze = 13986816  'der Lottozahlengenerierungen

'Eingabe\FSO-Drives.frm
Public fso As New FileSystemObject
Public dr As Drive
Public drLaufwerk As String
Public drLaufwerksbuchstabe As String

Public NotifySichtbar As Boolean
Public Ladevorgang As Boolean
Public i As Long                   'Schleifenzhler

Public Sub Notifyanzeigen()
NotifySichtbar = True
FensterffnenSound
    Set ND = New NotifyDialog
    
    Call ND.Create(App.Title & " ( Datum: " & Format(Date, "ddd dd.mm.yyyy") & " ) ", _
        "Der " & App.Title & " zeigt dir Feiertage, Geburtstage und Termine an !" _
        & vbCrLf & vbCrLf & "Er macht es dir fast unmglich einen Feiertag, Geburtstag" _
        & vbCrLf & "oder" & vbCrLf & "einen Termin in Zukunft noch zu vergessen !", 370 _
        , 200, 2, 8000 _
    )
End Sub

'Umwandlen einer Systemfarbe nach RGB
Public Function SysColortoRGB(ByVal nColor As OLE_COLOR) As Long
If (nColor And &HFF000000) = &H80000000 Then _
nColor = GetSysColor(nColor And &HFFFFFF)

SysColortoRGB = nColor
End Function

Public Sub Freeze()
'Fenster einfrieren
  LockWindowUpdate (GetDesktopWindow)
End Sub

Public Sub Defrost()
'Fenster wieder normal anzeigen
  LockWindowUpdate (0&)
End Sub

'Farbanteil BLAU
Public Function ColorBlue(ByVal Color As Long) As Integer
  ColorBlue = Color \ &H10000 And &HFF&
End Function

'Farbanteil GRN
Public Function ColorGreen(ByVal Color As Long) As Integer
  ColorGreen = Color \ &H100& And &HFF&
End Function

'Farbanteil ROT
Public Function ColorRed(ByVal Color As Long) As Integer
  ColorRed = Color And &HFF&
End Function

'Parameterbeschreibung
'Obj:  Form oder Picture-Objekt
'FromColor: Farbwert Anfangsfarbe
'ToColor:   Farbwert Endfarbe
'Direction: 1 = von oben nach unten
'           2 = von links nach rechts

Public Sub MakeGradient(Obj As Object, ByVal FromColor As Long, _
  ByVal ToColor As Long, ByVal Direction As Integer)

  Static ColorBits As Long
  Static RgnCnt As Integer
  
  Dim NbrPlanes As Long
  Dim BitsPerPixel As Long
  Dim AreaHeight As Long
  Dim AreaWidth As Long
  Dim prevScaleMode As Integer
  Dim IntervalX As Long
  Dim IntervalY As Long
  Dim i As Integer
  Dim r As Long
  Dim R_ColorVal As Long
  Dim G_ColorVal As Long
  Dim B_ColorVal As Long
  Dim FillArea As RECT
  Dim hBrush As Long
  Dim ColRed As Integer
  Dim ColGreen As Integer
  Dim ColBlue As Integer
 
  With Obj
    If ColorBits = 0 Then
      BitsPerPixel = GetDeviceCaps(.hDC, BITSPIXEL)
      NbrPlanes = GetDeviceCaps(.hDC, PLANES)
      ColorBits = (BitsPerPixel * NbrPlanes)
    
      Select Case ColorBits
        Case 32:  RgnCnt = 256
        Case 24:  RgnCnt = 256
        Case 16:  RgnCnt = 256
        Case 15:  RgnCnt = 32
        Case 8:   RgnCnt = 64
        Case 4:   RgnCnt = 64
        Case Else
          ColorBits = 4
          RgnCnt = 64
      End Select
    End If
    
    prevScaleMode = .ScaleMode
    .ScaleMode = 3
    AreaHeight = .ScaleHeight
    AreaWidth = .ScaleWidth
    .ScaleMode = prevScaleMode
    
    R_ColorVal = Int((ColorRed(FromColor) - _
     ColorRed(ToColor) + 1) / RgnCnt * 70)
    G_ColorVal = Int((ColorGreen(FromColor) - _
     ColorGreen(ToColor) + 1) / RgnCnt * 70)
    B_ColorVal = Int((ColorBlue(FromColor) - _
     ColorBlue(ToColor) + 1) / RgnCnt * 40)
    
    ColRed = ColorRed(ToColor) * 100
    ColGreen = ColorGreen(ToColor) * 100
    ColBlue = ColorBlue(ToColor) * 100
    
    IntervalY = Int(AreaHeight / RgnCnt * 100)
    IntervalX = Int(AreaWidth / RgnCnt * 100)
    
    With FillArea
      .Left = 0
      .Top = 0
      .Right = AreaWidth
      .Bottom = AreaHeight
    End With
        
    For i = 0 To RgnCnt - 1
      hBrush = CreateSolidBrush(RGB(ColRed / 100, _
       ColGreen / 100, ColBlue / 100))
      If Direction = 1 Then
        FillArea.Top = AreaHeight - (i * IntervalY / 100)
        r = FillRect(.hDC, FillArea, hBrush)
        FillArea.Bottom = FillArea.Top
      Else
        FillArea.Left = AreaWidth - (i * IntervalX / 100)
        r = FillRect(.hDC, FillArea, hBrush)
        FillArea.Right = FillArea.Left
      End If
      r = DeleteObject(hBrush)
      If i < RgnCnt - 1 Then
        ColRed = ColRed + R_ColorVal
        ColGreen = ColGreen + G_ColorVal
        ColBlue = ColBlue + B_ColorVal
      End If
    Next i
    
    FillArea.Top = 0
    FillArea.Left = 0
    hBrush = CreateSolidBrush(RGB(Int(ColRed / 100), _
     Int(ColGreen / 100), Int(ColBlue / 100)))
    r = FillRect(.hDC, FillArea, hBrush)
    r = DeleteObject(hBrush)
  End With
End Sub
