Attribute VB_Name = "mdlDatumsberechnungen"
Option Explicit

Enum eFeiertage
    Aschermittwoch = -46
    Karfreitag = -2
    Ostersonntag = 0
    Ostermontag = 1
    Christihimmelfahrt = 39
    Pfingstsonntag = 49
    Pfingstmontag = 50
    Fronleichnam = 60
End Enum

'wird gebraucht in der Feiertaganzeigen-Prozedur
Public Neujahr As Date
Public HeiligeDreiKnige As Date
Public ErsterMai As Date
Public TgdtEinheit As Date
Public Allerheiligen As Date
Public ErsterWeihnachtsfeiertag As Date
Public ZweiterWeihnachtsfeiertag As Date
Public valFeiertagdatum As Date            'Variable fr die Aufnahme eines Feiertagdatums
'Speichervariablen fr die entsprechenden Farben

Public Const ColorFeiertag = vbRed             'Farbe der Feiertage
Public ColorSonntag As OLE_COLOR
Public ColorMontag As OLE_COLOR
Public ColorDienstag As OLE_COLOR
Public ColorMittwoch As OLE_COLOR
Public ColorDonnerstag As OLE_COLOR
Public ColorFreitag As OLE_COLOR
Public ColorSamstag As OLE_COLOR
Public Const ColorStandardfarbe = &H8000000F   'Farbe der Schaltflchenoberseite

Public Function FeiertagDatum(ByVal intJahr As Integer, Optional Feiertag As eFeiertage) As Date

    Dim X As Integer, k As Integer, m As Integer
    Dim s As Integer, A As Integer, D As Integer
    Dim r As Integer, OG As Integer, SZ As Integer
    Dim OE As Integer, OS As Integer
    Dim Monat As Integer
    
    'intJahr ist der Wert des Combinationsfeldes
    X = intJahr
    'Eingabewert / 100
    k = Int(X / 100)
    
    m = 15 + Int((k * 3 + 3) / 4) - Int((k * 8 + 13) / 25)
    
    s = 2 - Int((3 * k + 3) / 4)
    
    A = X Mod 19
    
    D = (19 * A + m) Mod 30
    
    r = Int(D / 29) + (Int(D / 28) - Int(D / 29)) * Int(A / 11)
    
    OG = 21 + D - r
    
    SZ = 7 - (X + Int(X / 4) + s) Mod 7
    
    OE = 7 - (OG - SZ) Mod 7
    
    OS = OG + OE
    
    Monat = 3
    
If OS > 31 Then
    OS = OS - 31
    Monat = Monat + 1
End If

FeiertagDatum = DateSerial(X, Monat, OS)
    
    Select Case Feiertag
        Case eFeiertage.Aschermittwoch
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Aschermittwoch)
            
        Case eFeiertage.Karfreitag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Karfreitag)
            
        Case eFeiertage.Ostersonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostersonntag)
            
        Case eFeiertage.Ostermontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Ostermontag)

        Case eFeiertage.Christihimmelfahrt
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Christihimmelfahrt)
            
        Case eFeiertage.Pfingstsonntag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstsonntag)
            
        Case eFeiertage.Pfingstmontag
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Pfingstmontag)
            
        Case eFeiertage.Fronleichnam
            FeiertagDatum = DateAdd("d", FeiertagDatum, eFeiertage.Fronleichnam)
            
        Case Else
    End Select
End Function

Public Sub Feiertagehervorheben()
On Error GoTo Fehlerbehandlung
    On Error Resume Next
Dim iDatum As Date
'MsgBox iTage, vbInformation, "Monatsletzter"
    For i = 0 To 34
        If i <= iTage - 1 Then
            With FrmKalender.optTag(i)
                'das Datum feststellen und dann ...
                iDatum = .Caption & "." & iMonat & "." & iJahr
                'das entsprechende Datum mit den Feiertagen vergleichen
                If iDatum = FeiertagDatum(iJahr, Aschermittwoch) Then
                    .BackColor = ColorFeiertag  'Rot einfrben
                End If
            
                If iDatum = FeiertagDatum(iJahr, Karfreitag) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Ostersonntag) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Ostermontag) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Christihimmelfahrt) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Pfingstsonntag) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Pfingstmontag) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = FeiertagDatum(iJahr, Fronleichnam) Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = Neujahr Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = HeiligeDreiKnige Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = ErsterMai Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = TgdtEinheit Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = Allerheiligen Then
                    .BackColor = ColorFeiertag
                End If
            
                'If iDatum = Weihnachten Then
                '    .BackColor = ColorFeiertag
                'End If
                
                If iDatum = ErsterWeihnachtsfeiertag Then
                    .BackColor = ColorFeiertag
                End If
            
                If iDatum = ZweiterWeihnachtsfeiertag Then
                    .BackColor = ColorFeiertag
                End If
            End With
        End If
    Next
Exit Sub
Fehlerbehandlung:
    MsgBox Err.Description, vbCritical, "Fehler : " & Err.Number
End Sub

Public Sub Feiertaganzeigen()
DatummitFeiertagVergleichen iJahr, Right(FrmKalender.lblAnzeige.Caption, 10)
'MsgBox DatumamFeiertag & Chr(13) & strFeiertag, vbInformation, "Datum am Feiertag"

With FrmKalender.lblFeiertage

    If DatumamFeiertag = True Then
        FrmKalender.lblSchaltjahr.Visible = False
        .Visible = True
        .Caption = strFeiertag
    Else
        .Visible = False
        FrmKalender.lblSchaltjahr.Visible = True
    End If
End With
    
End Sub

Public Sub Feiertageanzeigen()
    
'alle Feiertage den entsprechenden Jahres anzeigen
With FrmKalender.MSFlexGridFeiertage
    .Height = 4700
    .Width = 4250
    .Rows = 16
    .Cols = 3
    .ColWidth(0) = 500
    .ColWidth(1) = 2500
    
    .TextMatrix(0, 0) = "ID.:"
    .TextMatrix(0, 1) = "Feiertag:"
    .TextMatrix(0, 2) = "Datum:"

    For i = 1 To 15
        .TextMatrix(i, 0) = i
    Next
    .TextMatrix(1, 1) = "Neujahr:"
    .TextMatrix(1, 2) = Neujahr
    .TextMatrix(2, 1) = "Heilige drei Knige:"
    .TextMatrix(2, 2) = HeiligeDreiKnige
    .TextMatrix(3, 1) = "Aschermittwoch:"
    .TextMatrix(3, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Aschermittwoch)
    .TextMatrix(4, 1) = "Karfreitag:"
    .TextMatrix(4, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Karfreitag)
    .TextMatrix(5, 1) = "Ostersonntag:"
    .TextMatrix(5, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Ostersonntag)
    .TextMatrix(6, 1) = "Ostermontag:"
    .TextMatrix(6, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Ostermontag)
    .TextMatrix(7, 1) = "1. Mai:"
    .TextMatrix(7, 2) = ErsterMai
    .TextMatrix(8, 1) = "Christi Himmelfahrt:"
    .TextMatrix(8, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Christihimmelfahrt)
    .TextMatrix(9, 1) = "Pfingstsonntag:"
    .TextMatrix(9, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Pfingstsonntag)
    .TextMatrix(10, 1) = "Pfingstmontag:"
    .TextMatrix(10, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Pfingstmontag)
    .TextMatrix(11, 1) = "Fronleichnam:"
    .TextMatrix(11, 2) = FeiertagDatum(intJahr:=iJahr, Feiertag:=Fronleichnam)
    .TextMatrix(12, 1) = "Tag d. deutschen Einheit:"
    .TextMatrix(12, 2) = TgdtEinheit
    .TextMatrix(13, 1) = "Allerheiligen:"
    .TextMatrix(13, 2) = Allerheiligen
    .TextMatrix(14, 1) = "1. Weihnachtsfeiertag:"
    .TextMatrix(14, 2) = ErsterWeihnachtsfeiertag
    .TextMatrix(15, 1) = "2. Weihnachtsfeiertag:"
    .TextMatrix(15, 2) = ZweiterWeihnachtsfeiertag

iJahr = FrmKalender.cboJahr.Text
End With
End Sub

Public Sub Datumberechnen()
On Error GoTo Fehlerbehandlung
Call Freeze
With FrmKalender
    Monatserster = DateSerial(.cboJahr.Text, .cboMonat.ListIndex + 1, 1)
    Monatsletzter = (DateSerial(.cboJahr.Text, .cboMonat.ListIndex + 2, 1) - 1)
    iTage = Left(Monatsletzter, 2)
    
    For i = 0 To 6
        'in die Labelfelder die entsprechenden Wochentage _
        in Form von z.B. Montag, Dienstag usw. eintragen
        .lblWochentag(i).Caption = Format(Monatserster + i, "ddd")
        .lblWochentag(i).Tag = Format(Monatserster + i, "dddd")
        'dem entsprechendem Wochentag die Farbe zuweisen
        Select Case .lblWochentag(i).Caption
            Case "So"
                If ColorSonntag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorSonntag
                End If
            Case "Mo"
                If ColorMontag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorMontag
                End If
            Case "Di"
                If ColorDienstag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorDienstag
                End If
            Case "Mi"
                If ColorMittwoch = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorMittwoch
                End If
            Case "Do"
                If ColorDonnerstag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorDonnerstag
                End If
            Case "Fr"
                If ColorFreitag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorFreitag
                End If
            Case "Sa"
                If ColorSamstag = 0 Then
                    .lblWochentag(i).BackColor = ColorStandardfarbe  'Standardschaltflchenfarbe
                Else
                    .lblWochentag(i).BackColor = ColorSamstag
                End If
        End Select
        
        'den entsprechenden Wochentag ganz ausgeschrieben _
        in der entsprechenden Tag-Eigenschaft zwischenspeichern
        .optTag(i).Tag = Format(Monatserster + i, "dddd")
        .optTag(i).BackColor = .lblWochentag(i).BackColor
        .optTag(i + 7).Tag = Format(Monatserster + i, "dddd")
        .optTag(i + 7).BackColor = .lblWochentag(i).BackColor
        .optTag(i + 14).Tag = Format(Monatserster + i, "dddd")
        .optTag(i + 14).BackColor = .lblWochentag(i).BackColor
        .optTag(i + 21).Tag = Format(Monatserster + i, "dddd")
        .optTag(i + 21).BackColor = .lblWochentag(i).BackColor
        .optTag(i + 28).Tag = Format(Monatserster + i, "dddd")
        .optTag(i + 28).BackColor = .lblWochentag(i).BackColor
    Next
    
    For i = 0 To 34
        'hier werden die Tages-Zahlen des entsprechenden Monats eingetragen
        If i <= iTage - 1 Then
            'wenn i den Wert kleiner oder gleich dem Wert von Monatsletzten hat dann ...
            .optTag(i).Caption = Format(i + 1, "00")   'entsprechend beschriften
            .optTag(i).Enabled = True
        Else
            .optTag(i).Caption = Format(i - iTage + 1, "00") 'die Tage des nchsten Monats eintragen
        
            If .optTag(i).Caption < iTage And .optTag(i).Value = True Then
                .optTag(i).Value = False
                .optTag(iTage - 1).Value = True
            End If
            .optTag(i).Enabled = False
        End If
    Next
Call Defrost
End With
Exit Sub
Fehlerbehandlung:
Call Defrost
End Sub

Public Sub Datumanzeigen()
On Error GoTo Fehlerbehandlung
    On Error Resume Next
Dim TageJahr As Integer
Dim datum As Date
With FrmKalender
datum = Format(iTag, "00") & "." & Format(iMonat, "00") & "." & iJahr

'ber die Funktion fktTageJahr _
die Anzahl der Tage des aktuellen Jahres ermitteln
TageJahr = fktTageJahr(datum)
'Wert abfragen
If TageJahr = 365 Then  'kein Schaltjahr
    .lblSchaltjahr.Caption = "das Jahr " & Format(datum, "yyyy") _
    & " ist kein Schaltjahr mit " & TageJahr & " Tagen !"
    .lblSchaltjahr.ForeColor = vbBlack
Else    'gibt nur noch den anderen Wert 366 Tage (ist ein Schaltjahr)
    .lblSchaltjahr.Caption = "das Jahr " & Format(datum, "yyyy") _
    & " ist ein Schaltjahr mit " & TageJahr & " Tagen !"
    .lblSchaltjahr.ForeColor = vbBlue
End If
        
    .lblAnzeige.Caption = Format(datum, "ddd dd.mm.yyyy")
    .lblKW.Caption = fktKalenderWoche(datum)
    .lblQuartal.Caption = DatePart("q", datum)

    'zeigt den Tag des Jahres, des Datums, als Zahl an
    .lblTagdesJahres.Caption = "der " & Format(datum, "dd. mmmm yyyy") _
    & " ist der " & DatePart("y", datum) _
    & ". Tag des Jahres !"

    'zeigt die noch verbleibenden Tage des Jahres an
    .lblRestTage.Caption = "das Jahr " & iJahr & " hat noch " _
    & TageJahr - DatePart("y", datum) & " ganze Tage !"
End With
    Feiertaganzeigen
Exit Sub
Fehlerbehandlung:
Fehlermeldung
End Sub

Public Sub HeutigesDatum()
Screen.MousePointer = vbHourglass
With FrmKalender
    .cboJahr.ListIndex = Format(Date, "yyyy") - 1900
    .cboMonat.ListIndex = Format(Date, "mm") - 1
    'MsgBox Format(Date, "dd")
    For i = 0 To 34
        If .optTag(i).Caption = Format(Date, "dd") Then
            If i + 1 = Format(Date, "dd") Then
                .optTag(i).Value = True
            End If
        Else
            .optTag(i).Value = False
        End If
    Next
End With
    'nun die entsprechenden Tage berechnen, anzeigen und evtl. hervorheben
    Datumberechnen
    Datumanzeigen
    Feiertagehervorheben
Screen.MousePointer = vbDefault
End Sub

Public Function fktJahreszeit(ByVal datum As Date, ByVal iJahr As Integer) As String

Const Frhlingsanfang = "20.03."
Const Sommeranfang = "21.06."
Const Herbstanfang = "22.09."
Const Winteranfang = "21.12."

Select Case datum
    Case Is < Frhlingsanfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Winter ( Winteranfang : " _
        & Winteranfang & iJahr - 1 & " )"
    Case Is < Sommeranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Frhling ( Frhlingsanfang : " _
        & Frhlingsanfang & iJahr & " )"
    Case Is < Herbstanfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Sommer ( Sommeranfang : " _
        & Sommeranfang & iJahr & " )"
    Case Is < Winteranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Herbst ( Herbstanfang : " _
        & Herbstanfang & iJahr & " )"
    Case Is >= Winteranfang & Right(datum, 4)
        fktJahreszeit = "Jahreszeit : Winter ( Winteranfang : " _
        & Winteranfang & iJahr & " )"
End Select
End Function

Public Function fktTageJahr(ByVal datum As Date) As Integer
    'die Tage des entsprechenden Jahres ausrechnen
    fktTageJahr = DateDiff("d", "01.01." & Format(datum, "yyyy"), _
    "31.12." & Format(datum, "yyyy")) + 1
End Function

Public Function fktKalenderWoche(ByVal datum As Date) As Integer
    'die aktuelle Kalenderwoche des entsprechenden Jahres ausrechnen
    fktKalenderWoche = DatePart("ww", datum, , vbFirstFourDays)
End Function

Public Function fktAlter(ByVal Geburtsdatum As Date) As Double
'rechnet das aktuelle Alter aus
    fktAlter = FormatNumber((Now - (Geburtsdatum - 1)) / 365.25)
End Function

Public Function fktAlterGeburtstag(ByVal Geburtsdatum As Date, ByVal Kalenderdatum As Date) As Double
'rechnet das differenz aus
    fktAlterGeburtstag = FormatNumber((Kalenderdatum - Geburtsdatum) / 365.25)
End Function
