Attribute VB_Name = "mdlOfficeMen"
Option Explicit

'Der restliche Code kommt in ein Modul:

' Code by Martin Walcher
' info@martinwalcher.de
' http://www.martinwalcher.de/

Private Declare Function SetWindowLong Lib "user32.dll" _
  Alias "SetWindowLongA" ( _
  ByVal hwnd As Long, _
  ByVal nIndex As Long, _
  ByVal dwNewLong As Long) As Long

Private Declare Function CallWindowProc Lib "user32.dll" _
  Alias "CallWindowProcA" ( _
  ByVal lpPrevWndFunc As Long, _
  ByVal hwnd As Long, _
  ByVal msg As Long, _
  ByVal wParam As Long, _
  ByVal lParam As Long) As Long

Private Declare Function SetPixel Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal X As Long, _
  ByVal Y As Long, _
  ByVal crColor As Long) As Long

Private Declare Function GetSysColor Lib "user32.dll" ( _
  ByVal nIndex As Long) As Long

Private Declare Function CreatePen Lib "gdi32.dll" ( _
  ByVal nPenStyle As Long, _
  ByVal nWidth As Long, _
  ByVal crColor As Long) As Long

Private Declare Function CreateSolidBrush Lib "gdi32.dll" ( _
  ByVal crColor As Long) As Long

Private Declare Function Rectangle Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal X1 As Long, _
  ByVal Y1 As Long, _
  ByVal X2 As Long, _
  ByVal Y2 As Long) As Long

Private Declare Function SelectObject Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal hObject As Long) As Long

Private Declare Function DeleteObject Lib "gdi32.dll" ( _
  ByVal hObject As Long) As Long

Private Declare Function SetTextColor Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal crColor As Long) As Long

Private Declare Function TextOut Lib "gdi32.dll" _
  Alias "TextOutA" ( _
  ByVal hdc As Long, _
  ByVal X As Long, _
  ByVal Y As Long, _
  ByVal lpString As String, _
  ByVal nCount As Long) As Long

Private Declare Function SetBkMode Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal nBkMode As Long) As Long

Private Declare Function GetMenu Lib "user32.dll" ( _
  ByVal hwnd As Long) As Long

Private Declare Function GetSubMenu Lib "user32.dll" ( _
  ByVal hMenu As Long, _
  ByVal nPos As Long) As Long

Private Declare Function GetMenuString Lib "user32.dll" _
  Alias "GetMenuStringA" ( _
  ByVal hMenu As Long, _
  ByVal wIDItem As Long, _
  ByVal lpString As String, _
  ByVal nMaxCount As Long, _
  ByVal wFlag As Long) As Long

Private Declare Function LineTo Lib "gdi32.dll" ( _
  ByVal hdc As Long, _
  ByVal X As Long, _
  ByVal Y As Long) As Long

Private Declare Function GetMenuState Lib "user32.dll" ( _
  ByVal hMenu As Long, _
  ByVal wID As Long, _
  ByVal wFlags As Long) As Long

Private Declare Function ModifyMenu Lib "user32.dll" _
  Alias "ModifyMenuA" ( _
  ByVal hMenu As Long, _
  ByVal nPosition As Long, _
  ByVal wFlags As Long, _
  ByVal wIDNewItem As Long, _
  ByVal lpString As Any) As Long

Private Declare Function GetMenuItemID Lib "user32.dll" ( _
  ByVal hMenu As Long, _
  ByVal nPos As Long) As Long

Private Declare Function SetMenuItemBitmaps Lib "user32.dll" ( _
  ByVal hMenu As Long, _
  ByVal nPosition As Long, _
  ByVal wFlags As Long, _
  ByVal hBitmapUnchecked As Long, _
  ByVal hBitmapChecked As Long) As Long

Private Declare Function GetMenuItemInfo Lib "user32.dll" _
  Alias "GetMenuItemInfoA" ( _
  ByVal hMenu As Long, _
  ByVal un As Long, _
  ByVal b As Boolean, _
  ByRef lpMenuItemInfo As MENUITEMINFO) As Long

Private Declare Function TransparentBlt Lib "msimg32.dll" ( _
  ByVal hdc As Long, _
  ByVal X As Long, _
  ByVal Y As Long, _
  ByVal nWidth As Long, _
  ByVal nHeight As Long, _
  ByVal hSrcDC As Long, _
  ByVal xSrc As Long, _
  ByVal ySrc As Long, _
  ByVal nSrcWidth As Long, _
  ByVal nSrcHeight As Long, _
  ByVal crTransparent As Long) As Long

Private Declare Sub CopyMemory Lib "kernel32.dll" _
  Alias "RtlMoveMemory" ( _
  ByRef Destination As Any, _
  ByRef Source As Any, _
  ByVal Length As Long)

Private Type RECT
  Left As Long
  Top As Long
  Right As Long
  Bottom As Long
End Type

Private Type MEASUREITEMSTRUCT
  CtlType As Long
  CtlID As Long
  itemID As Long
  itemWidth As Long
  itemHeight As Long
  itemData As Long
End Type

Private Type DRAWITEMSTRUCT
  CtlType As Long
  CtlID As Long
  itemID As Long
  itemAction As Long
  itemState As Long
  hwndItem As Long
  hdc As Long
  rcItem As RECT
  itemData As Long
End Type

Private Type MENUITEMINFO
  cbSize As Long
  fMask As Long
  fType As Long
  fState As Long
  wID As Long
  hSubMenu As Long
  hbmpChecked As Long
  hbmpUnchecked As Long
  dwItemData As Long
  dwTypeData As String
  cch As Long
End Type

Private Const GWL_WNDPROC As Long = -4
Private Const WM_MEASUREITEM As Long = &H2C
Private Const WM_DRAWITEM As Long = &H2B
Private Const COLOR_BACKGROUND As Long = 1
Private Const COLOR_MENU As Long = 4
Private Const COLOR_MENUTEXT As Long = 7
Private Const PS_SOLID As Long = 0
Private Const TRANSPARENT As Long = 1
Private Const MF_SEPARATOR As Long = &H800&
Private Const MF_BYPOSITION As Long = &H400&
Private Const MF_OWNERDRAW As Long = &H100&
Private Const MIIM_CHECKMARKS As Long = &H8

'die Farben des Mens
Public Const DefaultMenfarbe = &HFFFFFF
Public Const DefaultSelectMenfarbe = &HE0E0E0

Public selectMenfarbe As OLE_COLOR
Public standartMenfarbeNeu As OLE_COLOR

'die ursprngliche Einstellung (in NewProc)
    'rc = 255 - Round(X / 26 * (177 - 212))  'Rot
    'gc = 200 - Round(X / 26 * (257 - 208))  'Grn
    'bc = 255 - Round(X / 26 * (257 - 230))  'Blau

'die verschiedenen Default RotWerte
Public Const DefaultAnfangsRotWert = 255
Public Const DefaultMitteRotWert = 177
Public Const DefaultAbzugRotWert = 212
'die verschiedenen Default GrnWerte
Public Const DefaultAnfangsGrnWert = 200
Public Const DefaultMitteGrnWert = 257
Public Const DefaultAbzugGrnWert = 208
'die verschiedenen Default BlauWerte
Public Const DefaultAnfangsBlauWert = 255
Public Const DefaultMitteBlauWert = 257
Public Const DefaultAbzugBlauWert = 230

'die verschiedenen manuell eingestellten RotWerte
Public AnfangsRotWert As OLE_COLOR
Public MitteRotWert As OLE_COLOR
Public AbzugRotWert As OLE_COLOR
'die verschiedenen Default GrnWerte
Public AnfangsGrnWert As OLE_COLOR
Public MitteGrnWert As OLE_COLOR
Public AbzugGrnWert As OLE_COLOR
'die verschiedenen Default BlauWerte
Public AnfangsBlauWert As OLE_COLOR
Public MitteBlauWert As OLE_COLOR
Public AbzugBlauWert As OLE_COLOR

Public Menbildgre As String

Dim oldProc As Long

Sub DelProc(ByVal hwnd As Long)
  SetWindowLong hwnd, GWL_WNDPROC, oldProc
End Sub

Private Function DrawDiffuseRect(ByVal hdc As Long, r As RECT) As Boolean
  Dim nr As RECT, c As Long
  
  nr.Left = Rnd * (r.Right - r.Left - Rnd * 40) + r.Left
  If nr.Left <= r.Left Then nr.Left = r.Left + 1
  nr.Right = nr.Left + Rnd * 30 + 10
  If nr.Right >= r.Right Then nr.Right = r.Right - 1
  nr.Top = Rnd * (r.Bottom - r.Top - Rnd * 30) + r.Top
  If nr.Top <= r.Top Then nr.Top = r.Top + 1
  nr.Bottom = nr.Top + Rnd * 20 + 10
  If nr.Bottom >= r.Bottom Then nr.Bottom = r.Bottom - 1
  
  c = 20
  c = RGB(178 + Rnd * c - c / 2, 186 + Rnd * c - c / 2, 208 + Rnd * c - c / 2)
  DrawRect hdc, nr, c, c
End Function

Private Sub DrawRect(ByVal hdc As Long, r As RECT, _
  ByVal bc As Long, ByVal fc As Long)

  Dim hp As Long, hb As Long
  hp = CreatePen(PS_SOLID, 0, bc)
  hb = CreateSolidBrush(fc)
  SelectObject hdc, hp
  SelectObject hdc, hb
  Rectangle hdc, r.Left, r.Top, r.Right, r.Bottom
  DeleteObject hb
  DeleteObject hp
End Sub

Public Function GetMenuBitmap(ByVal hwnd As Long, _
  ByVal menuid As Long) As Long

  Dim mi As MENUITEMINFO
  mi.cbSize = Len(mi)
  mi.fMask = MIIM_CHECKMARKS
  GetMenuBitmap = GetMenuItemInfo(hwnd, menuid, False, mi)
  GetMenuBitmap = mi.hbmpUnchecked
End Function

Private Function MakeDiffuseRect(ByVal hdc As Long, r As RECT, _
  ByVal anzahl As Long) As Boolean

  Dim i As Long
  For i = 1 To anzahl
    DrawDiffuseRect hdc, r
  Next
End Function

Public Function MakeMenuOfficeStyle(ByVal hwnd As Long) As Boolean
  Dim xm As Long, xi As Long, m As Long, i As Long, r As Long
  
  xm = GetMenu(hwnd)
  
  xi = 0
  m = GetSubMenu(xm, xi)
  While Not m = 0
    i = 0
    r = GetMenuItemID(m, i)
    While Not r = -1
      ModifyMenu m, r, GetMenuState(m, r, 0) Or MF_OWNERDRAW, r, ""
      i = i + 1
      r = GetMenuItemID(m, i)
    Wend
    xi = xi + 1
    m = GetSubMenu(xm, xi)
  Wend
End Function

Private Function NewProc(ByVal hwnd As Long, ByVal msg As Long, _
  ByVal wParam As Long, ByVal lParam As Long) As Long

  Dim mis As MEASUREITEMSTRUCT, dis As DRAWITEMSTRUCT
  Dim r As RECT, s As String, X As Long, Y As Long
  Dim c As Long, rc As Long, gc As Long, bc As Long
  
  Select Case msg
  Case WM_MEASUREITEM
    CopyMemory mis, ByVal lParam, Len(mis)
    mis.itemWidth = 225 'hier ist die Breite des Mens einstellbar
        If (GetMenuState(GetMenu(hwnd), mis.itemID, 0) And MF_SEPARATOR) = _
          MF_SEPARATOR Then mis.itemHeight = 3 Else mis.itemHeight = 25
          'durch nderung von 25 auf z.B. 50 wird die Menhhe eingestellt
    CopyMemory ByVal lParam, mis, Len(mis)
  
  Case WM_DRAWITEM
    CopyMemory dis, ByVal lParam, Len(dis)
    
    s = Space(64)
    GetMenuString GetMenu(hwnd), dis.itemID, s, Len(s), 0
    s = Left(s, InStr(s & Chr(0), Chr(0)) - 1)
    s = Replace(s, "&", "")
    
    Select Case dis.itemState And 1
    
    Case 0  'nicht selektiert
        If standartMenfarbeNeu = 0 Then
            'durch ndern von &HFFFFFF auf einen anderen Wert _
            kann die standartMenfarbe festgelegt werden
            DrawRect dis.hdc, dis.rcItem, vbWhite, DefaultMenfarbe
        Else
            DrawRect dis.hdc, dis.rcItem, vbWhite, standartMenfarbeNeu
        End If
      'durch nderung von 25 auf z.B. 50 wird die Breite des Gradients eingestellt
      For X = dis.rcItem.Left To dis.rcItem.Left + 40
        'durch nderung der Zahlen kann die Farbe des Gradients gendert werden
        If AnfangsRotWert = 0 Then
            rc = DefaultAnfangsRotWert - Round(X / 26 * (DefaultMitteRotWert - DefaultAbzugRotWert))  'Rot
        Else
            rc = AnfangsRotWert - Round(X / 26 * (MitteRotWert - AbzugRotWert))  'Rot
        End If
        If AnfangsGrnWert = 0 Then
            gc = DefaultAnfangsGrnWert - Round(X / 26 * (DefaultMitteGrnWert - DefaultAbzugGrnWert))  'Grn
        Else
            gc = AnfangsGrnWert - Round(X / 26 * (MitteGrnWert - AbzugGrnWert))  'Grn
        End If
        If AnfangsBlauWert = 0 Then
            bc = DefaultAnfangsBlauWert - Round(X / 26 * (DefaultMitteBlauWert - DefaultAbzugBlauWert))  'Blau
        Else
            bc = AnfangsBlauWert - Round(X / 26 * (MitteBlauWert - AbzugBlauWert))  'Blau
        End If
        c = rc + gc * 256 + bc * 256 ^ 2
        For Y = dis.rcItem.Top To dis.rcItem.Bottom
          SetPixel dis.hdc, X, Y, c
        Next
      Next
      
      Select Case (dis.itemState And 6) = 6
      Case True
        r.Left = dis.rcItem.Left + 30
        r.Right = dis.rcItem.Right
        r.Top = dis.rcItem.Top + 2
        r.Bottom = r.Top + 1
        DrawRect dis.hdc, r, &H808080, &H808080
      Case False
        SetBkMode dis.hdc, TRANSPARENT
        SetTextColor dis.hdc, 0
      'durch nderung von 34 auf 68 wird der Text zentriert dargestellt
        TextOut dis.hdc, dis.rcItem.Left + 50, dis.rcItem.Top + _
          (dis.rcItem.Bottom - dis.rcItem.Top) / 2 - 12 / 2, s, Len(s)
      End Select
    
    Case 1  'selektiert
      r.Left = dis.rcItem.Left + 1
      r.Top = dis.rcItem.Top + 1
      r.Right = dis.rcItem.Right - 1
      r.Bottom = dis.rcItem.Bottom
      'der Wert &H6A240A gibt die Rahmenfarbe zurck, _
      &HD0BAB2 gibt die Menfarbe zurck whrend die Mouse _
      ber dem entsprechenden Men ist
      'durch ndern von &HD0BAB2 auf einen anderen Wert _
      z.B. &H00FFC0C0& (Lila) kann die Menfarbe gendert werden
      If selectMenfarbe = 0 Then
        DrawRect dis.hdc, r, &H6A240A, DefaultSelectMenfarbe
      Else
        DrawRect dis.hdc, r, &H6A240A, selectMenfarbe
      End If
      ' fr unregelmige Rechtecke
      ' vor MakeDiffuseRect entfernen
      ' MakeDiffuseRect dis.hdc, r, 20
      SetBkMode dis.hdc, TRANSPARENT
      SetTextColor dis.hdc, 0
      'durch nderung von 34 auf 68 wird der Text zentriert dargestellt
      TextOut dis.hdc, dis.rcItem.Left + 60, dis.rcItem.Top + _
        (dis.rcItem.Bottom - dis.rcItem.Top) / 2 - 12 / 2, s, Len(s)
    
    End Select
    
    c = GetMenuBitmap(dis.hwndItem, dis.itemID)
    If Menbildgre = "" Then
        If Not c = 0 Then TransparentBlt dis.hdc, dis.rcItem.Left + 5 - _
          (dis.itemState And 1), dis.rcItem.Top + 4 - (dis.itemState And 1), _
          32, 32, c, 0, 0, 32, 32, vbMagenta
    Else
        If Not c = 0 Then TransparentBlt dis.hdc, dis.rcItem.Left + 5 - _
          (dis.itemState And 1), dis.rcItem.Top + 4 - (dis.itemState And 1), _
          Menbildgre, Menbildgre, c, 0, 0, Menbildgre, Menbildgre, vbMagenta
    End If
  'durch nderung von 16,16 auf jeweils 32,32 wird das Menbild grer dargestellt
  End Select
  NewProc = CallWindowProc(oldProc, hwnd, msg, wParam, lParam)
End Function

Public Function SetMenuBitmap(ByVal hwnd As Long, ByVal menunr As Long, _
  ByVal menupos As Long, ByVal hdc As Long) As Boolean

  SetMenuBitmap = SetMenuItemBitmaps(GetSubMenu(GetMenu(hwnd), menunr), _
    menupos, MF_BYPOSITION, hdc, 0) = 1
End Function

Sub SetProc(ByVal hwnd As Long)
  oldProc = SetWindowLong(hwnd, GWL_WNDPROC, AddressOf NewProc)
End Sub
